@echo off
if "%1"=="" goto usage
if "%2"=="" goto usage
if "%3"=="" goto usage
if "%4"=="" goto usage
goto run

:usage
echo JKS2PFX
echo The GNU General Public License version 2 or later applies.
echo http://www.gnu.org/licenses/gpl.html
echo Converts Java JKS keystore private key and public certificate to PFX format
echo which can be imported into Microsoft keystores.
echo Creates the file "certificate.pfx" in the current directory.
echo usage: JKS2PFX keystore password alias exportname Java_Runtime_Folder
goto end
:run

if "%5"=="" goto run2
set PATH=%PATH%;%5

:run2
set KEYSTORE=%1
set PASSWORD=%2
set ALIAS=%3
set PKEY_8=privatekey.pkcs8
set PKEY_64=%4%.key
set CERT_64=%4%.crt
set CERT_P12=%4%.pfx
set OPENSSL_CONF=openssl.conf
keytool -export -rfc -keystore %KEYSTORE% -storepass %PASSWORD% -alias %ALIAS% > %CERT_64%
java -classpath . ExportPrvKey %KEYSTORE% %PASSWORD% %ALIAS% > %PKEY_8%
echo -----BEGIN PRIVATE KEY----- > %PKEY_64%
openssl enc -in %PKEY_8% -a >> %PKEY_64%
echo -----END PRIVATE KEY----- >> %PKEY_64%
echo Generating new PFX Key/Certificate pair, please enter a password
openssl pkcs12 -inkey %PKEY_64% -in %CERT_64% -out %CERT_P12% -export
del /q %PKEY_8%
echo Created new PEM key  : %PKEY_64%  (without password)
echo Created new PEM cert : %CERT_64%
echo Created new PFX file : %CERT_P12%  (with password)
:end